Attribute VB_Name = "modTimer"
Option Explicit

Private Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As LARGE_INTEGER) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As LARGE_INTEGER) As Long

Private Type LARGE_INTEGER
    Lo As Long
    Hi As Long
End Type

Private h_Start As LARGE_INTEGER
Private h_Stop As LARGE_INTEGER
Private h_Frequency As LARGE_INTEGER
Private h_Temp As Double

Public Sub Calibrate_()

    Call QueryPerformanceFrequency(h_Frequency)
    Call QueryPerformanceCounter(h_Start)
    Call QueryPerformanceCounter(h_Stop)
    
    h_Temp = (calc(h_Stop) - calc(h_Start)) / calc(h_Frequency) * 1000
End Sub

Public Sub Start_()
    Call QueryPerformanceCounter(h_Start)
End Sub

Public Sub Stop_()
    Call QueryPerformanceCounter(h_Stop)
End Sub

Public Function Runtime_() As Double
    Runtime_ = (calc(h_Stop) - calc(h_Start)) / calc(h_Frequency) * 1000 - h_Temp
End Function

Private Function calc(ByRef x As LARGE_INTEGER) As Double
    Const i As Double = 2 ^ 32
    
    Dim l As Double, h As Double
    
    l = x.Lo
    h = x.Hi
    
    If l < 0 Then l = i + l + 1
    If h < 0 Then h = i + h + 1
    
    calc = l + h * i
End Function
